/*
	D.O Arquelphos, etc...
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned long	header_filest = 0;
	unsigned long	header_fileed = 0;
	unsigned long	header_filesize = 0;
	char			header_filename[13];
	char			out_filename[256];
	unsigned long	nowsize;

	int				i = 0;

	printf( "DO Type2 File Divider 070611 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: DODIV2 <filename> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	printf( "\n" );

	buf = ( unsigned char * )calloc( 1, 0x10 );

	for( i = 0; i != 1024; i++ )
	{
		memset( header_filename, 0, sizeof( header_filename ));

		fseek( in, 2 + i * 0x10, SEEK_SET );
		fread( buf, 0x20, 1, in );

		header_filest = *( unsigned long *)( buf + 0x0C );
		header_fileed = *( unsigned long *)( buf + 0x1C );
		header_filesize = header_fileed - header_filest;
		memcpy( header_filename, &buf[0], 12 );

		printf( "%04d : %-12s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		if( ac == 3 )
		{
			sprintf( out_filename, "%s%s",
				av[2],
				header_filename
			);
		} else sprintf( out_filename, "%s", header_filename );

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );	/* 32k */
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );

		fclose( out );
		printf( ".\n" );
		free( filebuf );

		if( buf[0x10] == 0 ) break;
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
